unit PBWatcher;
//Author:	Poul Bak
//Copyright  2000 : BakSoft-Denmark (Poul Bak). All rights reserved.
//http://home11.inet.tele.dk/BakSoft/
//Mailto: baksoft-denmark@dk2net.dk

//Version: 2.00.00.00

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Menus, StdCtrls, ComCtrls, ExtCtrls, ShellAPI, ClipBrd, Registry, DsgnIntf;

const
	_PBMAX_VARIABLES = 1000;
	WM_PBTOOLTRAYICON = WM_USER + 1;
	HIDEWATCHFORM = 1;
	SHOWWATCHFORM = 2;

type
	TIncludeTime = (itNone, itTime, itTickCount);

	TWatchRecord = record
		VarName : string;
		WatchCounter, TotalCounter, LastTime : Cardinal;
	end;

	TPBWatchForm = class(TForm)
		WatchEdit: TRichEdit;
		Menu1: TMainMenu;
		File1: TMenuItem;
		Open1: TMenuItem;
		Save1: TMenuItem;
		N1: TMenuItem;
		Print1: TMenuItem;
		Settings1: TMenuItem;
		Enabled1: TMenuItem;
		PauseBetweenWatches1: TMenuItem;
		OpenDialog1: TOpenDialog;
		SaveDialog1: TSaveDialog;
		PrintDialog1: TPrintDialog;
		StayOnTop1: TMenuItem;
		AutoAdd1: TMenuItem;
		WatchAbove: TMenuItem;
		WatchBelow: TMenuItem;
		N3: TMenuItem;
		WatchObjectAbove: TMenuItem;
		WatchObjectBelow: TMenuItem;
		N5: TMenuItem;
		WatchPointerAbove: TMenuItem;
		WatchPointerBelow: TMenuItem;
		N6: TMenuItem;
		WatchPointAbove: TMenuItem;
		WatchPointBelow: TMenuItem;
		N7: TMenuItem;
		WatchRectAbove: TMenuItem;
		WatchRectBelow: TMenuItem;
		AddToWatches1: TMenuItem;
		AutoAdd2: TMenuItem;
		WatchCharAbove: TMenuItem;
		WatchCharBelow: TMenuItem;
		N8: TMenuItem;
		WatchIntAbove: TMenuItem;
		WatchIntBelow: TMenuItem;
		N9: TMenuItem;
		WatchFloatAbove: TMenuItem;
		WatchFloatBelow: TMenuItem;
		N10: TMenuItem;
		WatchBoolAbove: TMenuItem;
		WatchBoolBelow: TMenuItem;
		N11: TMenuItem;
		WatchColorAbove: TMenuItem;
		WatchColorBelow: TMenuItem;
		N12: TMenuItem;
		WatchCursorAbove: TMenuItem;
		WatchCursorBelow: TMenuItem;
		N13: TMenuItem;
		AutoSavewatches1: TMenuItem;
		Includetime1: TMenuItem;
		Includecounter1: TMenuItem;
		Maxwatches1: TMenuItem;
		Skipwatches1: TMenuItem;
		Help1: TMenuItem;
    Action1: TMenuItem;
		ClearWatch1: TMenuItem;
    ResetCounterPause1: TMenuItem;
		N2: TMenuItem;
    FindDialog1: TFindDialog;
    Findtext1: TMenuItem;
		RemoveWatches1: TMenuItem;
    AddToUsesClause1: TMenuItem;
    AutoAdd3: TMenuItem;
    WatchStringsabove: TMenuItem;
    WatchStringsbelow: TMenuItem;
		N4: TMenuItem;
    WatchComponentsAbove: TMenuItem;
    WatchComponentsBelow: TMenuItem;
    N14: TMenuItem;
		KeepInClipBoard1: TMenuItem;
    N15: TMenuItem;
		WatchByteAbove: TMenuItem;
		WatchByteBelow: TMenuItem;
    N16: TMenuItem;
    WatchMenuItemAbove: TMenuItem;
		WatchMenuItemBelow: TMenuItem;
    N17: TMenuItem;
    WatchMenuAbove: TMenuItem;
    WatchMenuBelow: TMenuItem;
		function GetEditWindow : TForm;
		procedure SendKeys(Keys : string);
		procedure SendVKey(Key : integer);
		procedure InsertLine(WatchProc : string; Below : Boolean);
		procedure Enabled1Click(Sender: TObject);
		procedure PauseBetweenWatches1Click(Sender: TObject);
		procedure Open1Click(Sender: TObject);
		procedure Save1Click(Sender: TObject);
		procedure Print1Click(Sender: TObject);
		procedure StayOnTop1Click(Sender: TObject);
		procedure ResetCounterPause1Click(Sender: TObject);
		procedure FormShowHide(Sender: TObject);
		procedure WatchClick(Sender: TObject);
		procedure WatchObjectClick(Sender: TObject);
		procedure WatchPointerClick(Sender: TObject);
		procedure WatchPointClick(Sender: TObject);
		procedure WatchRectClick(Sender: TObject);
		procedure WatchColorClick(Sender: TObject);
		procedure WatchCursorClick(Sender: TObject);
		procedure WatchMenuItemClick(Sender: TObject);
		procedure WatchCharClick(Sender: TObject);
		procedure WatchIntClick(Sender: TObject);
		procedure WatchByteClick(Sender: TObject);
		procedure WatchFloatClick(Sender: TObject);
		procedure WatchBoolClick(Sender: TObject);
		procedure WatchStringsClick(Sender: TObject);
		procedure WatchComponentsClick(Sender: TObject);
		procedure WatchMenuClick(Sender: TObject);
		procedure AddToWatches1Click(Sender: TObject);
		procedure WndProc(var Msg : TMessage); override;
		procedure AutoSavewatches1Click(Sender: TObject);
		procedure Includecounter1Click(Sender: TObject);
		procedure Includetime1Click(Sender: TObject);
		procedure Skipwatches1Click(Sender: TObject);
		procedure Maxwatches1Click(Sender: TObject);
		procedure Help1Click(Sender: TObject);
		procedure Findtext1Click(Sender: TObject);
		procedure FindDialog1Find(Sender: TObject);
		procedure FindDialog1Close(Sender: TObject);
		procedure RemoveWatches1Click(Sender: TObject);
		procedure ClearWatch1Click(Sender: TObject);
		procedure AddToUsesClause1Click(Sender: TObject);
		procedure KeepInClipBoard1Click(Sender: TObject);
	private
		TempVisible, TempEnabled : Boolean;
	end;

	TPBWatchTrayIcon = class(TPersistent)
	private
		FHWnd : HWnd;
		FIconData : TNotifyIconData;
		FVisible : Boolean;
		constructor Create;
		destructor Destroy; override;
		function ShowIcon : Boolean;
		function HideIcon :Boolean;
		procedure WndProc(var Msg : TMessage);
	end;

	TPBWatcher = class(TPersistent)
	private
		{ Private declarations }
		FEnabled, FVisible, FStayOnTop : Boolean;
		FAutoSaveWatch, FIncludeCounter, FAddToWatches, FKeepInClipBoard : Boolean;
		FPauseBetweenWatches, FMaxWatches, FSkipWatches, FVarNumber : Cardinal;
		FIncludeTime : TIncludeTime;
		FFileDir, FFileName, FHelpFile : string;
		FPBWatchForm: TPBWatchForm;
		FPBWatchTrayIcon : TPBWatchTrayIcon;
		FWatchRecords : array[0.._PBMAX_VARIABLES] of TWatchRecord;
		constructor Create;
		destructor Destroy; override;
		function BoolToStr(Value : Boolean) : string;
		function Proceed(Name : string) : Boolean;
		procedure UpdateWatch(Name, Value : string);
		procedure SetAddToWatches(Value : Boolean);
		procedure SetAutoSaveWatch(Value : Boolean);
		procedure SetEnabled(Value : Boolean);
		procedure SetIncludeCounter(Value : Boolean);
		procedure SetIncludeTime(Value : TIncludeTime);
		procedure SetMaxWatches(Value : Cardinal);
		procedure SetPauseBetweenWatches(Value : Cardinal);
		procedure SetSkipWatches(Value : Cardinal);
		procedure SetStayOnTop(Value : Boolean);
		procedure SetVisible(Value : Boolean);
	protected
		{ Protected declarations }
	public
		{ Public declarations }
		procedure Clear;
		procedure ResetCounter;
		procedure Watch(const VarName : string; const Value : Variant);
		procedure WatchObject(const VarName : string; const Value : TObject);
		procedure WatchPointer(const VarName : string; const Value : Pointer);
		procedure WatchPoint(const VarName : string; const Value : TPoint);
		procedure WatchRect(const VarName : string; const Value : TRect);
		procedure WatchColor(const VarName : string; const Value : TColor);
		procedure WatchCursor(const VarName : string; const Value : TCursor);
		procedure WatchMenuItem(const VarName : string; const Value : TMenuItem);
		procedure WatchCharArray(const VarName : string; const Values : array of Char);
		procedure WatchIntArray(const VarName : string; const Values : array of integer);
		procedure WatchByteArray(const VarName : string; const Values : array of Byte);
		procedure WatchFloatArray(const VarName : string; const Values : array of extended);
		procedure WatchBoolArray(const VarName : string; const Values : array of Boolean);
		procedure WatchStrings(const VarName : string; const Value : TStrings);
		procedure WatchComponents(const VarName : string; const Value : TComponent);
		procedure WatchMenu(const VarName : string; const Value : TComponent);
		property AddToWatches : Boolean read FAddToWatches write SetAddToWatches;
		property AutoSaveWatch : Boolean read FAutoSaveWatch write SetAutoSaveWatch;
		property FileDir : string read FFileDir write FFileDir;
		property FileName : string read FFileName write FFileName;
		property Enabled : Boolean read FEnabled write SetEnabled;
		property IncludeCounter : Boolean read FIncludeCounter write SetIncludeCounter;
		property IncludeTime : TIncludeTime read FIncludeTime write SetIncludeTime;
		property MaxWatches : Cardinal read FMaxWatches write SetMaxWatches;
		property PauseBetweenWatches : Cardinal read FPauseBetweenWatches write SetPauseBetweenWatches;
		property SkipWatches : Cardinal read FSkipWatches write SetSkipWatches;
		property StayOnTop : Boolean read FStayOnTop write SetStayOnTop;
		property Visible : Boolean read FVisible write SetVisible;
	end;

function Watcher : TPBWatcher;

implementation

{$R *.DFM}

type
	TPBWatchMenuAdder = class(TPersistent)
	private
		PBWatchMenu, N1, ViewMenu : TMenuItem;
		constructor Create;
		destructor Destroy; override;
		procedure PBWatchMenuClick(Sender : TObject);
	end;

var
	PBWatcherObject : TPBWatcher = nil;
	PBWatchMenuAdder : TPBWatchMenuAdder = nil;
	HideShowMessage : DWord = 0;
	IsDesigning : Boolean = False;
	RefCount : integer = 0;
	HasFoundOne : Boolean = False;

function Watcher : TPBWatcher;
begin
	if RefCount = 0 then PBWatcherObject := TPBWatcher.Create;
	Result := PBWatcherObject;
end;

//  ----------------- PBWatcher object ------------------------
constructor TPBWatcher.Create;
var
	Reg : TRegistry;
	Buffer : array[0..MAX_PATH] of Char;
	TempVisible : Boolean;
	Keys : TStringList;
	t : integer;
	SearchPath : string;
	PWndPlacement : PWindowPlacement;
begin
	inherited Create;
	Inc(RefCount);
	PBWatcherObject := Self;
	FPBWatchForm := TPBWatchForm.Create(nil);
	Enabled := True;
	FVisible := False;
	TempVisible := True;
	StayOnTop := True;
	AutoSaveWatch := False;
	SkipWatches := 0;
	MaxWatches := 0;
	PauseBetweenWatches := 0;
	AddToWatches := True;
	IncludeTime := itNone;
	IncludeCounter := False;
	if IsDesigning then FKeepInClipBoard := True;
	GetTempPath(MAX_PATH, Buffer);
	FFileDir := String(Buffer);
	HideShowMessage := RegisterWindowMessage('PBWatchHideShowDesigning');
	if IsDesigning then FPBWatchTrayIcon := nil
	else FPBWatchTrayIcon := TPBWatchTrayIcon.Create;
	with FPBWatchForm do
	begin
		Left := Screen.Width div 2 + 1;
		Top := -2;
		Height := 120;
		Width := Left + 2;
		if IsDesigning then Caption := 'PBWatcher - [Designmode]'
		else
		begin
			Caption := 'PBWatcher - [Runmode]';
			AutoAdd1.Enabled := False;
			AutoAdd2.Enabled := False;
			AutoAdd3.Enabled := False;
			AddToUsesClause1.Enabled := False;
			RemoveWatches1.Enabled := False;
			KeepInClipBoard1.Enabled := False;
		end;
		FFileName := Caption + '.txt';
	end;
	Reg := TRegistry.Create;
	with Reg do
	begin
		if OpenKey('\Software\Borland\Delphi\PBWatcher\' + FPBWatchForm.Caption, True) then
		begin
			with FPBWatchForm do
			begin
				GetMem(PWndPlacement, SizeOf(TWindowPlacement));
				PWndPlacement^.length := SizeOf(TWindowPlacement);
				GetWindowPlacement(Handle, PWndPlacement);
				if ValueExists('ShowCmd') then PWndPlacement^.showCmd := ReadInteger('ShowCmd')
				else PWndPlacement^.showCmd := SW_SHOWNORMAL;
				if ValueExists('Left') then PWndPlacement^.rcNormalPosition.Left := ReadInteger('Left')
				else PWndPlacement^.rcNormalPosition.Left := Left;
				if ValueExists('Top') then PWndPlacement^.rcNormalPosition.Top := ReadInteger('Top')
				else PWndPlacement^.rcNormalPosition.Top := Top;
				if ValueExists('Right') then PWndPlacement^.rcNormalPosition.Right := ReadInteger('Right')
				else PWndPlacement^.rcNormalPosition.Right := Left + Width;
				if ValueExists('Bottom') then PWndPlacement^.rcNormalPosition.Bottom := ReadInteger('Bottom')
				else PWndPlacement^.rcNormalPosition.Bottom := Top + Height;
				SetWindowPlacement(Handle, PWndPlacement);
				FreeMem(PWndPlacement);
			end;
			if ValueExists('AddToWatches') then AddToWatches := ReadBool('AddToWatches');
			if ValueExists('AutoSaveWatch') then AutoSaveWatch := ReadBool('AutoSaveWatch');
			if ValueExists('Enabled') then Enabled := ReadBool('Enabled');
			if ValueExists('FileDir') then FFileDir := ReadString('FileDir');
			if ValueExists('FileName') then FFileName := ReadString('FileName');
			if ValueExists('HelpFile') then FHelpFile := ReadString('HelpFile');
			if ValueExists('IncludeCounter') then IncludeCounter := ReadBool('IncludeCounter');
			if ValueExists('IncludeTime') then IncludeTime := TIncludeTime(ReadInteger('IncludeTime'));
			if ValueExists('KeepInClipBoard') then FKeepInClipBoard := ReadBool('KeepInClipBoard');
			if ValueExists('MaxWatches') then MaxWatches := ReadInteger('MaxWatches');
			if ValueExists('SkipWatches') then SkipWatches := ReadInteger('SkipWatches');
			if ValueExists('PauseBetweenWatches') then PauseBetweenWatches := ReadInteger('PauseBetweenWatches');
			if ValueExists('StayOnTop') then StayOnTop := ReadBool('StayOnTop');
			if ValueExists('Visible') then TempVisible := ReadBool('Visible');
		end;
		if not FileExists(FHelpFile) then
		begin
			GetWindowsDirectory(Buffer, MAX_PATH);
			if FileExists(string(Buffer) + '\Help\PBWatcher.chm')
				and FileExists(string(Buffer) + '\hh.exe')
				then FHelpFile := string(Buffer) + '\Help\PBWatcher.chm'
			else if FileExists(string(Buffer) + '\Help\PBWatcher.htm')
				then FHelpFile := string(Buffer) + '\Help\PBWatcher.htm'
			else if OpenKey('\Software\Borland\Delphi', False) then
			begin
				Keys := TStringList.Create;
				GetKeyNames(Keys);
				for t := 0 to Keys.Count - 1 do
				begin
					if Pos(Copy(Keys[t], 1, 2), '2.|3.|4.|5.|6.|7.|8.|9.') <> 0 then
					begin
						if OpenKey(Keys[t] + '\Library', False) then
						begin
							if ValueExists('SearchPath') then
							begin
								SearchPath := ReadString('SearchPath');
								FHelpFile := FileSearch('PBWatcher.chm', SearchPath);
								if (FHelpFile = '') or not FileExists(string(Buffer) + '\hh.exe')
								 then FHelpFile := FileSearch('PBWatcher.htm', SearchPath);
							end;
						end;
					end;
				end;
				Keys.Free;
			end;
		end;
	end;
	Reg.Free;
	FPBWatchForm.KeepInClipBoard1.Checked := FKeepInClipBoard;
	if FHelpFile = '' then FPBWatchForm.Help1.Enabled := False;
	Visible := TempVisible;
end;

destructor TPBWatcher.Destroy;
var
	Reg : TRegistry;
	PWndPlacement : PWindowPlacement;
begin
	Reg := TRegistry.Create;
	with Reg do
	begin
		if OpenKey('\Software\Borland\Delphi\PBWatcher\' + FPBWatchForm.Caption, True) then
		begin
			with FPBWatchForm do
			begin
				GetMem(PWndPlacement, SizeOf(TWindowPlacement));
				PWndPlacement^.length := SizeOf(TWindowPlacement);
				GetWindowPlacement(Handle, PWndPlacement);
				if FVisible then WriteInteger('ShowCmd', PWndPlacement^.showCmd)
				else WriteInteger('ShowCmd', 0);
				WriteInteger('Left', PWndPlacement^.rcNormalPosition.Left);
				WriteInteger('Top', PWndPlacement^.rcNormalPosition.Top);
				WriteInteger('Right', PWndPlacement^.rcNormalPosition.Right);
				WriteInteger('Bottom', PWndPlacement^.rcNormalPosition.Bottom);
				FreeMem(PWndPlacement);
			end;
			WriteBool('AddToWatches', FAddToWatches);
			WriteBool('AutoSaveWatch', FAutoSaveWatch);
			WriteBool('Enabled', FEnabled);
			WriteString('FileDir', FileDir);
			WriteString('FileName', FFileName);
			WriteString('HelpFile', FHelpFile);
			WriteBool('IncludeCounter', FIncludeCounter);
			WriteInteger('IncludeTime', Integer(FIncludeTime));
			WriteBool('KeepInClipBoard', FKeepInClipBoard);
			WriteInteger('MaxWatches', FMaxWatches);
			WriteInteger('PauseBetweenWatches', FPauseBetweenWatches);
			WriteInteger('SkipWatches', FSkipWatches);
			WriteBool('StayOnTop', FStayOnTop);
			WriteBool('Visible', FVisible);
			CloseKey;
		end;
	end;
	Reg.Free;
	FPBWatchTrayIcon.Free;
	FPBWatchForm.Free;
	Dec(RefCount);
	inherited Destroy;
end;

function TPBWatcher.BoolToStr(Value :  Boolean) : string;
begin
	if Value = True then Result := 'True'
	else Result := 'False';
end;

function TPBWatcher.Proceed(Name : string) : Boolean;
var
	t : integer;
begin
	Result := False;
	t := 0;
	while (FWatchRecords[t].VarName <> Name) and (FWatchRecords[t].VarName <> '')
		and (t <= _PBMAX_VARIABLES) do Inc(t);
	if t <= _PBMAX_VARIABLES then with FWatchRecords[t] do
	begin
		FVarNumber := t;
		if FPBWatchForm.Enabled1.Checked	and ((TotalCounter >= FSkipWatches) or (FSkipWatches = 0))
			and ((WatchCounter < FMaxWatches) or (FMaxWatches = 0))
			and (GetTickCount >= LastTime + FPauseBetweenWatches) then Result := True;
		Inc(TotalCounter);
	end;
end;

procedure TPBWatcher.UpdateWatch(Name, Value : string);
var
	TimeString, CounterString : string;
begin
	if FVarNumber <= _PBMAX_VARIABLES then with FWatchRecords[FVarNumber] do
	begin
		VarName := Name;
		Inc(WatchCounter);
		LastTime := GetTickCount;
	end;
	if FIncludeTime = itTime then TimeString := ' {' + TimeToStr(Time) + '}'
	else if FIncludeTime = itTickCount then TimeString := ' {' + IntToStr(GettickCount) + '}'
	else TimeString := '';
	if FIncludeCounter and (FVarNumber <= _PBMAX_VARIABLES) then
	begin
		if FWatchRecords[FVarNumber].WatchCounter <> FWatchRecords[FVarNumber].TotalCounter
			then CounterString := '  {#' + IntToStr(FWatchRecords[FVarNumber].WatchCounter)
			+ '/' + IntToStr(FWatchRecords[FVarNumber].TotalCounter) + '}'
		else CounterString := '  {#' + IntToStr(FWatchRecords[FVarNumber].WatchCounter) + '}';
	end
	else CounterString  := '';
	if FAddToWatches then FPBWatchForm.WatchEdit.Lines.Add(Name + '='
		+ Value + CounterString + TimeString)
	else FPBWatchForm.WatchEdit.Lines.Values[Name] :=
		Value + CounterString + TimeString;
	if FAutoSaveWatch then
	begin
		if FFileDir[Length(FFileDir)] = '\'
			then FPBWatchForm.WatchEdit.Lines.SaveToFile
			(FFileDir + FFileName)
		else FPBWatchForm.WatchEdit.Lines.SaveToFile
			(FFileDir + '\' + FFileName);
	end;
end;

procedure TPBWatcher.Watch(const VarName : string; const Value : Variant);
var
	ValueString : string;
begin
	if Proceed(VarName) then
	begin
		if (VarType(Value) and varBoolean) = varBoolean
			then ValueString := BoolToStr(Value)
		else ValueString := VarToStr(Value);
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchCharArray(const VarName : string; const Values : array of Char);
var
	t : integer;
	ValueString : string;
begin
	if Proceed(VarName) then
	begin
		ValueString := '(';
		for t := Low(Values) to High(Values) do
		begin
			if t > Low(Values) then ValueString := ValueString + ', ';
			if IsCharAlphaNumeric(Values[t])
				then ValueString := ValueString + '''' + Values[t] + ''''
			else ValueString := ValueString + '#' + IntToStr(Ord(Values[t]));
		end;
		ValueString := ValueString + ')';
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchIntArray(const VarName : string; const Values : array of integer);
var
	t : integer;
	ValueString : string;
begin
	if Proceed(VarName) then
	begin
		ValueString := '(';
		for t := Low(Values) to High(Values) do
		begin
			if t > Low(Values) then ValueString := ValueString + ', ';
			ValueString := ValueString + IntToStr(Values[t]);
		end;
		ValueString := ValueString + ')';
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchByteArray(const VarName : string; const Values : array of Byte);
var
	t : integer;
	ValueString : string;
begin
	if Proceed(VarName) then
	begin
		ValueString := '(';
		for t := Low(Values) to High(Values) do
		begin
			if t > Low(Values) then ValueString := ValueString + ', ';
			ValueString := ValueString + IntToStr(Values[t]);
		end;
		ValueString := ValueString + ')';
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchFloatArray(const VarName : string; const Values : array of extended);
var
	t : integer;
	ValueString : string;
begin
	if Proceed(VarName) then
	begin
		ValueString := '(';
		for t := Low(Values) to High(Values) do
		begin
			if t > Low(Values) then ValueString := ValueString + ',  ';
			ValueString := ValueString + FloatToStr(Values[t]);
		end;
		ValueString := ValueString + ')';
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchBoolArray(const VarName : string; const Values : array of Boolean);
var
	t : integer;
	ValueString : string;
begin
	if Proceed(VarName) then
	begin
		ValueString := '(';
		for t := Low(Values) to High(Values) do
		begin
			if t > Low(Values) then ValueString := ValueString + ', ';
			ValueString := ValueString + BoolToStr(Values[t]);
		end;
		ValueString := ValueString + ')';
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchObject(const VarName : string; const Value : TObject);
var
	ValueString : string;
	Ancestor : TClass;
begin
	if Proceed(VarName) then
	begin
		if Value = nil then ValueString := 'nil'
		else if Value is TComponent then ValueString := (Value as TComponent).Name
			+ ' [' + Value.ClassName + ']'
		else ValueString := ' [' + Value.ClassName + ']';
		if Value <> nil then
		begin
			Ancestor := Value.ClassParent;
			while Ancestor <> nil do
			begin
				ValueString := ValueString + ', [' + Ancestor.ClassName + ']';
				Ancestor := Ancestor.ClassParent;
			end;
		end;
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchPointer(const VarName : string; const Value : Pointer);
var
	ValueString : string;
begin
	if Proceed(VarName) then
	begin
		if Value = nil then ValueString := 'nil'
		else ValueString := '$' + IntToHex(Integer(Value), 8);
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchPoint(const VarName : string; const Value : TPoint);
var
	ValueString : string;
begin
	if Proceed(VarName) then
	begin
		ValueString := ' X:' + IntToStr(Value.x) + ' Y:' + IntToStr(Value.y);
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchRect(const VarName : string; const Value : TRect);
var
	ValueString : string;
begin
	if Proceed(VarName) then with Value do
	begin
		ValueString := ' Left:' + IntToStr(Left) + ' Top:' + IntToStr(Top)
			+ ' Right:' + IntToStr(Right) + ' Bottom:' + IntToStr(Bottom);
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchColor(const VarName : string; const Value : TColor);
begin
	if Proceed(VarName) then UpdateWatch(VarName, ColorToString(Value));
end;

procedure TPBWatcher.WatchCursor(const VarName : string; const Value : TCursor);
begin
	if Proceed(VarName) then UpdateWatch(VarName, CursorToString(Value));
end;

procedure TPBWatcher.WatchMenuItem(const VarName : string; const Value : TMenuItem);
var
	ValueString : string;
begin
	if Proceed(VarName) then
	begin
		ValueString := 'Name:' + Value.Name + ', Caption:' + Value.Caption
			+ ', Shortcut:'	+ ShortCutToText(Value.ShortCut) + ', Checked:'
			+ BoolToStr(Value.Checked) + ', Enabled:' + BoolToStr(Value.Enabled)
			+ 'Visible:' + BoolToStr(Value.Visible) + ', Hint:' + Value.Hint + ', OnClick:';
		if Assigned(Value.OnClick) then ValueString := ValueString + '$'
			+ IntToHex(Integer(@@Value.OnClick), 8)
		else ValueString := ValueString + 'nil';
		UpdateWatch(VarName, ValueString);
	end;
end;

procedure TPBWatcher.WatchStrings(const VarName : string; const Value : TStrings);
var
	t : integer;
begin
	if Proceed(VarName) then
	begin
		UpdateWatch(VarName, '');
		if not FAddToWatches then FPBWatchForm.WatchEdit.Clear;
		for t := 0 to Value.Count - 1 do UpdateWatch('[' + IntToStr(t) + ']', Value[t]);
	end;
end;

procedure TPBWatcher.WatchComponents(const VarName : string; const Value : TComponent);
var
	t : integer;
begin
	if Proceed(VarName) then
	begin
		if not FAddToWatches then FPBWatchForm.WatchEdit.Clear;
		WatchObject(VarName, Value);
		for t := 0 to Value.ComponentCount - 1
			do	WatchObject('Components[' + IntToStr(t)	+ ']', Value.Components[t]);
	end;
end;

procedure TPBWatcher.WatchMenu(const VarName : string; const Value : TComponent);
var
	t : integer;
begin
	if Proceed(VarName) then
	begin
		if not FAddToWatches then FPBWatchForm.WatchEdit.Clear;
		WatchObject(VarName, Value);
		if Value is TMenu then
		begin
			for t := 0 to (Value as TMenu).Items.Count - 1
				do WatchMenuItem('Items[' + IntToStr(t)	+ ']', (Value as TMenu).Items[t]);
		end
		else if Value is TMenuItem then
		begin
			for t := 0 to (Value as TMenuItem).Count - 1
				do WatchMenuItem('Items[' + IntToStr(t)	+ ']', (Value as TMenuItem)[t]);
		end;
	end;
end;

procedure TPBWatcher.Clear;
begin
	FPBWatchForm.ClearWatch1Click(Self);
end;

procedure TPBWatcher.ResetCounter;
begin
	FPBWatchForm.ResetCounterPause1Click(Self);
end;

procedure TPBWatcher.SetAddToWatches(Value : Boolean);
begin
	if FAddToWatches <> Value then
	begin
		FAddToWatches := Value;
		FPBWatchForm.AddToWatches1.Checked := Value;
	end;
end;

procedure TPBWatcher.SetAutoSaveWatch(Value : Boolean);
begin
	if FAutoSaveWatch <> Value then
	begin
		FAutoSaveWatch := Value;
		FPBWatchForm.AutoSavewatches1.Checked := Value;
	end;
end;

procedure TPBWatcher.SetEnabled(Value : Boolean);
begin
	if FEnabled <> Value then
	begin
		FEnabled := Value;
		FPBWatchForm.Enabled1.Checked := Value;
		FPBWatchForm.ResetCounterPause1Click(Self);
	end;
end;

procedure TPBWatcher.SetIncludeCounter(Value : Boolean);
begin
	if FIncludeCounter <> Value then
	begin
		FIncludeCounter := Value;
		FPBWatchForm.IncludeCounter1.Checked := Value;
	end;
end;

procedure TPBWatcher.SetIncludeTime(Value : TIncludeTime);
begin
	if FIncludeTime <> Value then
	begin
		FIncludeTime := Value;
		if Value = itNone then	FPBWatchForm.IncludeTime1.Caption := 'Include time (= itNone)'
		else if Value = itTime then	FPBWatchForm.IncludeTime1.Caption := 'Include time (= itTime)'
		else FPBWatchForm.IncludeTime1.Caption := 'Include time (= itTickCount)'
	end;
end;

procedure TPBWatcher.SetMaxWatches(Value : Cardinal);
begin
	if FMaxWatches <> Value then
	begin
		FMaxWatches := Value;
		FPBWatchform.Maxwatches1.Caption := '&Max watches (= ' + IntToStr(Value) + ')';
	end;
end;

procedure TPBWatcher.SetPauseBetweenWatches(Value : Cardinal);
begin
	if FPauseBetweenWatches <> Value then
	begin
		FPauseBetweenWatches := Value;
		FPBWatchform.PauseBetweenWatches1.Caption := '&Pause between watches (= ' + IntToStr(Value) + ')';
	end;
end;

procedure TPBWatcher.SetSkipWatches(Value : Cardinal);
begin
	if FSkipWatches <> Value then
	begin
		FSkipWatches := Value;
		FPBWatchform.Skipwatches1.Caption := '&Skip watches (= ' + IntToStr(Value) + ')';
	end;
end;

procedure TPBWatcher.SetStayOnTop(Value : Boolean);
begin
	if FStayOnTop <> Value then
	begin
		FStayOnTop := Value;
		if Value then FPBWatchForm.FormStyle := fsStayOntop
		else FPBWatchForm.FormStyle := fsNormal;
		FPBWatchForm.StayOnTop1.Checked := Value;
		FPBWatchForm.Repaint;
		Application.ProcessMessages;
	end;
end;

procedure TPBWatcher.SetVisible(Value : Boolean);
begin
	if FVisible <> Value then
	begin
		FVisible := Value;
		FPBWatchForm.Visible := Value;
	end;
end;

//  ----------------- PBWatchForm ------------------------
procedure TPBWatchForm.Enabled1Click(Sender: TObject);
begin
	PBWatcherObject.Enabled := not PBWatcherObject.Enabled;
end;

procedure TPBWatchForm.AddToWatches1Click(Sender: TObject);
begin
	PBWatcherObject.AddToWatches := not PBWatcherObject.AddToWatches;
end;

procedure TPBWatchForm.AutoSavewatches1Click(Sender: TObject);
begin
	PBWatcherObject.AutoSaveWatch := not PBWatcherObject.AutoSaveWatch;
end;

procedure TPBWatchForm.Includecounter1Click(Sender: TObject);
begin
	PBWatcherObject.IncludeCounter := not PBWatcherObject.IncludeCounter;
end;

procedure TPBWatchForm.Includetime1Click(Sender: TObject);
begin
	if PBWatcherObject.IncludeTime = itNone then PBWatcherObject.IncludeTime := itTime
	else if PBWatcherObject.IncludeTime = itTime then PBWatcherObject.IncludeTime := itTickCount
	else PBWatcherObject.IncludeTime := itNone;
end;

procedure TPBWatchForm.PauseBetweenWatches1Click(Sender: TObject);
begin
	PBWatcherObject.PauseBetweenWatches := StrToIntDef(InputBox
		('Pause between watches', 'Minimum milliseconds between watches:',
		IntToStr(PBWatcherObject.FPauseBetweenWatches)),
		PBWatcherObject.FPauseBetweenWatches);
end;

procedure TPBWatchForm.Skipwatches1Click(Sender: TObject);
begin
	PBWatcherObject.Skipwatches := StrToIntDef(InputBox
		('Skip watches', 'Number of watches to skip at start:',
		IntToStr(PBWatcherObject.FSkipWatches)),
		PBWatcherObject.FSkipWatches);
end;

procedure TPBWatchForm.Maxwatches1Click(Sender: TObject);
begin
	PBWatcherObject.Maxwatches := StrToIntDef(InputBox
		('Max watches', 'Maximum number of watches:',
		IntToStr(PBWatcherObject.FMaxWatches)),
		PBWatcherObject.FMaxWatches);
end;

procedure TPBWatchForm.ClearWatch1Click(Sender: TObject);
begin
	WatchEdit.Clear;
end;

procedure TPBWatchForm.Open1Click(Sender: TObject);
begin
	OpenDialog1.InitialDir := PBWatcherObject.FFileDir;
	OpenDialog1.FileName := PBWatcherObject.FFileName;
	if OpenDialog1.Execute then
	begin
		WatchEdit.Lines.LoadFromFile(OpenDialog1.FileName);
		if AnsiLowerCase(ExtractFileExt(OpenDialog1.FileName)) = '.txt' then
		begin
			PBWatcherObject.FFileDir := ExtractFilePath(OpenDialog1.FileName);
			PBWatcherObject.FFileName := ExtractFileName(OpenDialog1.FileName);
		end;
	end;
end;

procedure TPBWatchForm.Save1Click(Sender: TObject);
begin
	SaveDialog1.InitialDir := PBWatcherObject.FFileDir;
	SaveDialog1.FileName := PBWatcherObject.FFileName;
	if SaveDialog1.Execute then
	begin
		WatchEdit.Lines.SaveToFile(SaveDialog1.FileName);
		PBWatcherObject.FFileDir := ExtractFilePath(SaveDialog1.FileName);
		PBWatcherObject.FFileName := ExtractFileName(SaveDialog1.FileName);
	end;
end;

procedure TPBWatchForm.Print1Click(Sender: TObject);
begin
	if PrintDialog1.Execute then WatchEdit.Print('PBWatcher ' + DateTimeToStr(Now));
end;

procedure TPBWatchForm.StayOnTop1Click(Sender: TObject);
begin
	PBWatcherObject.StayOnTop := not PBWatcherObject.StayOnTop;
end;

procedure TPBWatchForm.ResetCounterPause1Click(Sender: TObject);
var
	t : integer;
begin
	for t := 0 to _PBMAX_VARIABLES do with PBWatcherObject.FWatchRecords[t] do
	begin
		TotalCounter := 0;
		WatchCounter := 0;
		LastTime := 0;
	end;
end;

procedure TPBWatchForm.FormShowHide(Sender: TObject);
begin
	if PBWatcherObject <> nil then
	begin
		PBWatcherObject.FVisible := Visible;
		if IsDesigning then
		begin
			if PBWatchMenuAdder <> nil then PBWatchMenuAdder.PBWatchMenu.Checked := Visible;
		end;
		if Visible then BringToFront;
	end;
end;

procedure TPBWatchForm.WatchClick(Sender: TObject);
begin
	InsertLine('Watch', (Sender = WatchBelow));
end;

procedure TPBWatchForm.WatchObjectClick(Sender: TObject);
begin
	InsertLine('WatchObject', (Sender = WatchObjectBelow));
end;

procedure TPBWatchForm.WatchPointerClick(Sender: TObject);
begin
	InsertLine('WatchPointer', (Sender = WatchPointerBelow));
end;

procedure TPBWatchForm.WatchPointClick(Sender: TObject);
begin
	InsertLine('WatchPoint', (Sender = WatchPointBelow));
end;

procedure TPBWatchForm.WatchRectClick(Sender: TObject);
begin
	InsertLine('WatchRect', (Sender = WatchRectBelow));
end;

procedure TPBWatchForm.WatchColorClick(Sender: TObject);
begin
	InsertLine('WatchColor', (Sender = WatchColorBelow));
end;

procedure TPBWatchForm.WatchCursorClick(Sender: TObject);
begin
	InsertLine('WatchCursor', (Sender = WatchCursorBelow));
end;

procedure TPBWatchForm.WatchMenuItemClick(Sender: TObject);
begin
	InsertLine('WatchMenuItem', (Sender = WatchMenuItemBelow));
end;

procedure TPBWatchForm.WatchCharClick(Sender: TObject);
begin
	InsertLine('WatchCharArray', (Sender = WatchCharBelow));
end;

procedure TPBWatchForm.WatchIntClick(Sender: TObject);
begin
	InsertLine('WatchIntArray', (Sender = WatchIntBelow));
end;

procedure TPBWatchForm.WatchByteClick(Sender: TObject);
begin
	InsertLine('WatchByteArray', (Sender = WatchByteBelow));
end;

procedure TPBWatchForm.WatchFloatClick(Sender: TObject);
begin
	InsertLine('WatchFloatArray', (Sender = WatchFloatBelow));
end;

procedure TPBWatchForm.WatchBoolClick(Sender: TObject);
begin
	InsertLine('WatchBoolArray', (Sender = WatchBoolBelow));
end;

procedure TPBWatchForm.WatchStringsClick(Sender: TObject);
begin
	InsertLine('WatchStrings', (Sender = WatchStringsBelow));
end;

procedure TPBWatchForm.WatchComponentsClick(Sender: TObject);
begin
	InsertLine('WatchComponents', (Sender = WatchComponentsBelow));
end;

procedure TPBWatchForm.WatchMenuClick(Sender: TObject);
begin
	InsertLine('WatchMenu', (Sender = WatchMenuBelow));
end;

procedure TPBWatchForm.SendKeys(Keys : string);
var
	t, KeyScan : integer;
begin
	if Keys <> '' then
	begin
		for t := 1 to Length(Keys) do
		begin
			KeyScan := VkKeyScan(Keys[t]);
			SendVKey(KeyScan);
		end;
	end;
end;

procedure TPBWatchForm.SendVKey(Key : integer);
begin
	if (HiByte(Key) and 1) = 1 then Keybd_Event(VK_SHIFT, MapVirtualKey(VK_SHIFT, 0), 0, 0);
	if (HiByte(Key) and 2) = 2 then Keybd_Event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
	if (HiByte(Key) and 4) = 4 then Keybd_Event(VK_MENU, MapVirtualKey(VK_MENU, 0), 0, 0);
	Keybd_Event((Key and 255), MapVirtualKey(Key, 0), 0, 0);
	Keybd_Event((Key and 255), MapVirtualKey(Key, 0), KEYEVENTF_KEYUP, 0);
	if (HiByte(Key) and 4) = 4 then Keybd_Event(VK_MENU, MapVirtualKey(VK_MENU, 0), KEYEVENTF_KEYUP, 0);
	if (HiByte(Key) and 2) = 2 then Keybd_Event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP, 0);
	if (HiByte(Key) and 1) = 1 then Keybd_Event(VK_SHIFT, MapVirtualKey(VK_SHIFT, 0), KEYEVENTF_KEYUP, 0);
end;

procedure TPBWatchForm.InsertLine(WatchProc : string; Below : Boolean);
var
	EditWindow : TForm;
	VarName, TempVarName : string;
	t : integer;
begin
	EditWindow := GetEditWindow;
	if EditWindow <> nil then
	begin
		EditWindow.SetFocus;
		if EditWindow.Active then
		begin
			ClipBoard.Clear;
			Application.ProcessMessages;
			SendVKey(512 + 67);
			Application.ProcessMessages;
			TempVarName := ClipBoard.AsText;
			VarName := '';
			t := 1;
			while t <= Length(TempVarName) do
			begin
				if TempVarName[t] = '''' then VarName := VarName + ''''''
				else VarName := VarName + TempVarName[t];
				Inc(t);
			end;
			if not Below then SendVKey(VK_UP);
			SendVKey(VK_END);
			SendVKey(VK_RETURN);
			SendVKey(VK_HOME);
			SendKeys('Watcher.' + WatchProc + '(''' + VarName + ''', '
				+ ClipBoard.AsText + ');');
			SendVKey(VK_HOME);
			if PBWatcherObject.FKeepInClipBoard then ClipBoard.AsText := 'Watcher.' + WatchProc
				+ '(''' + ClipBoard.AsText + ''', ' + ClipBoard.AsText + ');'#10#13;
		end;
	end;
end;

procedure TPBWatchForm.RemoveWatches1Click(Sender: TObject);
var
	EditWindow : TForm;
	t, Find0, Find1, Find2, Find3, Find4 : integer;
	Sep : Char;
	PText : PChar;
	ClipBoardHandle : THandle;
begin
	EditWindow := GetEditWindow;
	if EditWindow <> nil then
	begin
		EditWindow.SetFocus;
		if EditWindow.Active then
		begin
			SendVKey(512 + VK_HOME);
			Application.ProcessMessages;
			SendVKey(512 + 256 + VK_END);
			Application.ProcessMessages;
			SendVKey(512 + 67);
			Application.ProcessMessages;
			SendVKey(512 + VK_HOME);
			with WatchEdit do
			begin
				Clear;
				ClipBoard.Open;
				try
					ClipBoardHandle := Clipboard.GetAsHandle(CF_TEXT);
					PText := GlobalLock(ClipBoardHandle);
					Text := StrPas(PText);
					GlobalUnlock(ClipBoardHandle);
				finally
					ClipBoard.Close;
				end;
				Application.ProcessMessages;
				SelLength := 0;
				t := 0;
				while t < Lines.Count do
				begin
					if Pos('Watcher.Watch', TrimLeft(Lines[t])) <> 0 then Lines.Delete(t)
					else Inc(t);
				end;
				Find0 := FindText(#10'uses', 0, Length(Text), [stWholeWord]);
				if Find0 <> -1 then
				begin
					Find4 := FindText(';', Find0, Length(Text), []);
					Find2 := FindText('PBWatcher', Find0, Find4 - Find0, []);
					Find3 := FindText(',', Find2, Find4 - Find2, []);
					Find1 := FindText(',', Find0, Find2 - Find0, []);
					if (Find2 <> -1) and (Find4 > Find2) then
					begin
						SelStart := Find2;
						SelLength := 9;
						ClearSelection;
						if Find1 <> -1 then
						repeat
							SelStart := SelStart - 1;
							SelLength := 1;
							if SelLength = 0 then SelLength := 2;
							Sep := SelText[1];
							if (Sep in [',', ' ', #9, #10, #13]) then	ClearSelection;
						until Sep = ','
						else if Find3 <> -1 then
						repeat
							SelLength := 1;
							if SelLength = 0 then SelLength := 2;
							Sep := SelText[Length(SelText)];
							if (Sep in [',', ' ', #9, #10, #13]) then	ClearSelection;
						until not (Sep in [',', ' ', #9, #10, #13]);
					end;
				end;
				SelectAll;
				CopyToClipboard;
				Clear;
			end;
			EditWindow.SetFocus;
			if EditWindow.Active then
			begin
				SendVKey(512 + VK_HOME);
				Application.ProcessMessages;
				SendVKey(512 + 256 + VK_END);
				Application.ProcessMessages;
				SendVKey(512 + 86);
				Application.ProcessMessages;
				ClipBoard.Clear;
				SendVKey(512 + VK_HOME);
				Application.ProcessMessages;
				ShowMessage('PBWatches have been removed.'#10#13
					+'You can ''undo'' if you want.');
			end;
		end;
	end;
end;

procedure TPBWatchForm.AddToUsesClause1Click(Sender: TObject);
var
	EditWindow : TForm;
	Find0, Find1, Find2 : integer;
	PText : PChar;
	ClipBoardHandle : THandle;
begin
	EditWindow := GetEditWindow;
	if EditWindow <> nil then
	begin
		EditWindow.SetFocus;
		if EditWindow.Active then
		begin
			SendVKey(512 + VK_HOME);
			Application.ProcessMessages;
			SendVKey(512 + 256 + VK_END);
			Application.ProcessMessages;
			SendVKey(512 + 67);
			Application.ProcessMessages;
			SendVKey(512 + VK_HOME);
			Application.ProcessMessages;
			with WatchEdit do
			begin
				Clear;
				ClipBoard.Open;
				try
					ClipBoardHandle := Clipboard.GetAsHandle(CF_TEXT);
					PText := GlobalLock(ClipBoardHandle);
					Text := StrPas(PText);
					GlobalUnlock(ClipBoardHandle);
				finally
					ClipBoard.Close;
				end;
				Application.ProcessMessages;
				Find0 := FindText(#10'uses', 0, Length(Text), [stWholeWord]);
				if Find0 <> -1 then
				begin
					Find2 := FindText(';', Find0, Length(Text), []);
					Find1 := FindText('PBWatcher', Find0, Find2 - Find0, []);
					if Find1 <> -1 then
					begin
						Clear;
						Exit;
					end;
					if Find2 <> -1 then
					begin
						SelStart := Find2;
						SelLength := 0;
						SelText := ', PBWatcher';
					end;
				end;
				SelectAll;
				CopyToClipboard;
				Clear;
			end;
			EditWindow.SetFocus;
			if EditWindow.Active then
			begin
				SendVKey(512 + VK_HOME);
				Application.ProcessMessages;
				SendVKey(512 + 256 + VK_END);
				Application.ProcessMessages;
				SendVKey(512 + 86);
				Application.ProcessMessages;
				ClipBoard.Clear;
				SendVKey(512 + VK_HOME);
				Application.ProcessMessages;
			end;
		end;
	end;
end;

procedure TPBWatchForm.WndProc(var Msg : TMessage);
begin
	with Msg do
	begin
		if not (csDestroying in ComponentState) and (PBWatcherObject <> nil) then
		begin
			if (Msg = HideShowMessage) then
			begin
				if IsDesigning then
				begin
					if (wParam = SHOWWATCHFORM) and TempVisible then
					begin
						if not Visible then Show;
					end
					else if (wParam = HIDEWATCHFORM) then
					begin
						TempVisible := Visible;
						if Visible then Hide;
					end;
				end;
			end;
		end;
	end;
	inherited WndProc(Msg);
end;

procedure TPBWatchForm.Help1Click(Sender: TObject);
begin
	if FileExists(PBWatcherObject.FHelpFile) then ShellExecute(Handle, nil,
		PChar(PBWatcherObject.FHelpFile), nil, nil, SW_SHOWNORMAL);
end;

procedure TPBWatchForm.Findtext1Click(Sender: TObject);
begin
	TempEnabled := PBWatcherObject.Enabled;
	PBWatcherObject.Enabled := False;
	HasFoundOne := False;
	FindDialog1.Execute;
end;

procedure TPBWatchForm.FindDialog1Find(Sender: TObject);
var
	FoundAt: LongInt;
	StartPos, ToEnd: integer;
	SearchHow : TSearchTypes;
begin
	with WatchEdit do
	begin
		if SelLength <> 0 then StartPos := SelStart + SelLength
		else StartPos := 0;
		ToEnd := Length(Text) - StartPos;
		SearchHow := [];
		if (frMatchCase	in FindDialog1.Options) then SearchHow := [stMatchCase];
		if (frWholeWord	in FindDialog1.Options) then SearchHow :=
			SearchHow + [stWholeWord];
		FoundAt := FindText(FindDialog1.FindText, StartPos, ToEnd, SearchHow);
		if FoundAt <> -1 then
		begin
			HasFoundOne := True;
			SetFocus;
			SelStart := FoundAt;
			SelLength := Length(FindDialog1.FindText);
		end
		else if HasFoundOne then
		begin
			FoundAt := FindText(FindDialog1.FindText, 0, Length(Text), SearchHow);
			HasFoundOne := True;
			SetFocus;
			SelStart := FoundAt;
			SelLength := Length(FindDialog1.FindText);
		end
		else SelLength := 0;
	end;
end;

procedure TPBWatchForm.FindDialog1Close(Sender: TObject);
begin
	if TempEnabled then PBWatcherObject.Enabled := True;
	HasFoundOne := False;
end;

procedure TPBWatchForm.KeepInClipBoard1Click(Sender: TObject);
begin
	KeepInClipBoard1.Checked := not KeepInClipBoard1.Checked;
	PBWatcherObject.FKeepInClipBoard := KeepInClipBoard1.Checked;
end;

function TPBWatchForm.GetEditWindow : TForm;
var
	WinHandle1, WinHandle2 : HWnd;
	PText : array[0..256] of Char;
begin
	WinHandle1 := GetWindow(Self.Handle, GW_HWNDFIRST);
	repeat
		WinHandle2 := GetWindow(WinHandle1, GW_HWNDNEXT);
		if WinHandle2 <> 0 then
		begin
			WinHandle1 := WinHandle2;
			GetClassName(WinHandle2, PText, 255);
		end;
	until (PText = 'TEditWindow') or (WinHandle2 = 0);
	Result := nil;
	if (PText = 'TEditWindow') and (WinHandle2 <> 0)
		then if (FindControl(WinHandle2) is TForm)
			then Result := FindControl(WinHandle2) as TForm;
end;

//  ----------------- PBWatchTrayIcon ------------------------
constructor TPBWatchTrayIcon.Create;
var
	DesignModeWindow : HWnd;
begin
	inherited;
	FHWnd := AllocateHWnd(WndProc);
	with FIconData do
	begin
		cbSize := sizeof(TNOTIFYICONDATA);
		wnd := FHWnd;
		uID := 0;
		uFlags := NIF_MESSAGE + NIF_ICON + NIF_TIP;
		hIcon := PBWatcherObject.FPBWatchForm.Icon.Handle;
		StrPCopy(szTip, PBWatcherObject.FPBWatchForm.Caption);
		uCallbackMessage := WM_PBTOOLTRAYICON;
	end;
	ShowIcon;
	if not IsDesigning then
	begin
		DesignModeWindow := FindWindow('TPBWatchForm', 'PBWatcher - [DesignMode]');
		if DesignModeWindow <> 0 then SendMessage(DesignModeWindow, HideShowMessage, HIDEWATCHFORM, 0);
	end;
end;

destructor TPBWatchTrayIcon.Destroy;
var
	DesignModeWindow : HWnd;
begin
	if not IsDesigning then
	begin
		DesignModeWindow := FindWindow('TPBWatchForm', 'PBWatcher - [DesignMode]');
		if DesignModeWindow <> 0 then SendMessage(DesignModeWindow, HideShowMessage, SHOWWATCHFORM, 0);
	end;
	if FVisible then HideIcon;
	DeAllocateHWnd(FHWnd);
	inherited Destroy;
end;

procedure TPBWatchTrayIcon.WndProc(var Msg : TMessage);
begin
	with Msg do
	begin
		if (Msg = WM_PBTOOLTRAYICON) and (lParam = WM_LBUTTONDOWN)
			then with PBWatcherObject.FPBWatchForm do Visible := not Visible
		else Result := DefWindowProc(FHWnd, Msg, wParam, lParam);
	end;
end;

function TPBWatchTrayIcon.ShowIcon;
begin
	Result := Shell_NotifyIcon(NIM_ADD,@FIconData);
	FVisible := Result;
end;

function TPBWatchTrayIcon.HideIcon;
begin
	Result := Shell_NotifyIcon(NIM_DELETE,@FIconData);
	FVisible := Result;
end;

//  ----------------- PBWatchMenuAdder --------------------------
constructor TPBWatchMenuAdder.Create;
begin
	inherited;
	if Application.FindComponent('AppBuilder') <> nil
		then ViewMenu := Application.FindComponent('AppBuilder').FindComponent('ViewsMenu') as TMenuItem
	else ViewMenu := nil;
	if ViewMenu <> nil then
	begin
		N1 := NewLine;
		ViewMenu.Add(N1);
		PBWatchMenu := NewItem('PBWatcher Window', ShortCut(Word('W'), [ssCtrl]),
		False, True, PBWatchMenuClick, 0, 'PBWatchMenu');
		ViewMenu.Add(PBWatchMenu);
	end;
end;

destructor TPBWatchMenuAdder.Destroy;
begin
	if ViewMenu <> nil then
	begin
		if PBWatchMenu <> nil then
		begin
			if ViewMenu.IndexOf(PBWatchMenu) <> -1
				then ViewMenu.Delete(ViewMenu.IndexOf(PBWatchMenu));
			PBWatchMenu.Free;
			PBWatchMenu := nil;
		end;
		if N1 <> nil then
		begin
			if ViewMenu.IndexOf(N1) <> -1
				then ViewMenu.Delete(ViewMenu.IndexOf(N1));
			N1.Free;
			N1 := nil;
		end;
	end;
	inherited;
end;

procedure TPBWatchMenuAdder.PBWatchMenuClick(Sender : TObject);
begin
	PBWatchMenu.Checked := not PBWatchMenu.Checked;
	if PBWatcherObject <> nil then
	begin
		PBWatcherObject.FPBWatchForm.Visible := PBWatchMenu.Checked;
	end;
end;

//  ------------------- Initialization --------------------------
initialization
begin
	if CmdLine = nil then IsDesigning := True
	else if Pos('\DELPHI32.EXE', UpperCase(ParamStr(0))) > 0 then IsDesigning := True;
	if (RefCount = 0) then
	begin
		if IsDesigning and (PBWatchMenuAdder = nil)
			then PBWatchMenuAdder := TPBWatchMenuAdder.Create;
		if PBWatcherObject = nil then PBWatcherObject := TPBWatcher.Create;
	end
	else Inc(RefCount);
end;

//  ------------------- Finalization ----------------------------
finalization
begin
	if RefCount <= 1 then
	begin
		PBWatcherObject.Free;
		PBWatcherObject := nil;
		if IsDesigning then
		begin
			PBWatchMenuAdder.Free;
			PBWatchMenuAdder := nil;
		end;
	end
	else Dec(RefCount);
end;

end.

