unit Unit1;
// See also the project source (you can watch anywhere in your project
// - as long as you include 'PBWatcher' in the uses clause of the unit.
interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ExtCtrls, PBWatcher;

type
	TTestForm = class(TForm)
		Button1: TButton;
		Memo1: TMemo;
		Button2: TButton;
		Button3: TButton;
		Timer1: TTimer;
    Button4: TButton;
		procedure Button1Click(Sender: TObject);
		procedure Button2Click(Sender: TObject);
		procedure Button3Click(Sender: TObject);
		procedure Timer1Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
	private
		{ Private declarations }
	public
		{ Public declarations }
	end;

var
	TestForm: TTestForm;

implementation

{$R *.DFM}

procedure TTestForm.Button1Click(Sender: TObject);
var
	ExtendedVar : extended;
begin
// Watching standard value types using the procedure 'Watch'.
	ExtendedVar := Random(100)/7;
Watcher.Watch('Time', Time);
Watcher.Watch('BooleanVar', True);
Watcher.Watch('Integer', Trunc(Random(100)));
Watcher.Watch('Float (Random1)', Random(100)/7);
Watcher.Watch('ExtendedVar', ExtendedVar);
Watcher.Watch('TestForm.Caption', TestForm.Caption);
end;

procedure TTestForm.Button2Click(Sender: TObject);
begin
// Watching TStrings with 'Add To watches' set to false clears
// the watch-window so it shouldn't be combined with other watches !
	Memo1.Lines.Add('New line');
Watcher.WatchStrings('Memo1.Lines', Memo1.Lines);
end;

procedure TTestForm.Button3Click(Sender: TObject);
var
	CharArray : array[0..25] of Char;
	IntArray : array[1..12] of integer;
	ByteArray : array[0..5] of Byte;
	FloatArray : array[1..5] of extended;
	BoolArray : array[1..5] of Boolean;
	Dummy : TObject;
	t : integer;
begin
	CharArray := 'This is an array of Char' + #20 + #0169;
Watcher.Watch('CharArray as string', string(CharArray));
Watcher.WatchCharArray('CharArray', CharArray);
	for t := 1 to 12 do IntArray[t] := Random(1001);
Watcher.WatchIntArray('IntArray', IntArray);
	for t := 0 to 5 do ByteArray[t] := Random(255);
Watcher.WatchByteArray('ByteArray', ByteArray);
	for t := 1 to 5 do FloatArray[t] := Random(200)/7;
Watcher.WatchFloatArray('FloatArray', FloatArray);
	BoolArray[2] := True;
	BoolArray[4] := True;
Watcher.WatchBoolArray('BoolArray', BoolArray);
Watcher.WatchPointer('Pointer', nil);
Watcher.WatchObject('Sender', Sender);
	Dummy := nil;
Watcher.WatchObject('Dummy', Dummy);
Watcher.WatchPoint('Point', TestForm.ClientOrigin);
Watcher.WatchRect('Rect', TestForm.BoundsRect);
Watcher.WatchColor('Color', TestForm.Color);
Watcher.WatchCursor('Cursor', TestForm.Cursor);
end;

procedure TTestForm.Timer1Timer(Sender: TObject);
var
	Tick : Cardinal;
begin
// Try to watch 'Tick' using Delphi Watch window (it won't show anything) !
	Tick := GetTickCount;
Watcher.Watch('Tick', Tick);
end;

procedure TTestForm.Button4Click(Sender: TObject);
begin
// Watching Components with 'Add To watches' set to false clears
// the watch-window so it shouldn't be combined with other watches !
Watcher.WatchComponents('Application.MainForm', Application.MainForm);
end;

end.

